/*
 * qsockreader.h
 *
 *  Created on: Aug 1, 2013
 *      Author: root
 */

#ifndef QSOCKREADER_H_
#define QSOCKREADER_H_

#include "qstdinc.h"
#include "qsock.h"
#include "qbuffer.h"

/*
 * Default parameters
 */
#define Q_RS_ONE_READ 1024
#define Q_RS_ONE_LINE_MAX_LEN 8192
#define Q_RS_READ_SLEEP 100000

/*
 * Line modes
 */
#define Q_RS_LINEMODE_CRLF	1 	/* Default */
#define Q_RS_LINEMODE_LF	2

/*
 * Socket line reader
 */
struct QReadSockParams
{
	/* Init params */
	QReadSockParams()
	{
		/* Input params */
		nOneRead = Q_RS_ONE_READ;
		nLineMaxLen = Q_RS_ONE_LINE_MAX_LEN;
		nLineMode = Q_RS_LINEMODE_CRLF;
		nWaitTime = Q_RS_READ_SLEEP;
		bDebug = false;
	}

	/* Input parsing params */
	int		nOneRead;			/* One read from socket, max size 	*/
	int		nLineMaxLen;		/* Max length of one line			*/
	int		nLineMode;			/* Line detection mode				*/
	int		nWaitTime;			/* Wait time if no new line found	*/
	bool	bDebug;				/* Show input strings				*/
};

/* Return true if new line found, false otherwise */
bool QReadSocketLine(QBuffer& buffer, std::string& sLine, QTCPSock* pSock, QReadSockParams* pParams = NULL);
bool QReadBufferLine(QBuffer& buffer, std::string& sLine, uint8_t* pData, int nSize, QReadSockParams* pParams = NULL);

/* URL decoding */
bool QURLDecode(std::string& sLine);
bool QURLIsHex(char c);
int QURLCharToNumber(char c);

#endif /* QSOCKREADER_H_ */
